#ifndef MYTYPES_H
#define MYTYPES_H

// Возможные состояния клавиш
typedef enum {
  KEY_IS_UP,
  KEY_IS_DOWN,
  KEY_IS_GOING_UP,    // В этом состоянии мы увеличиваем таймер.
  KEY_IS_GOING_DOWN,  // В этом состоянии мы увеличиваем таймер.
} state_t;

// Возможные события
typedef enum {
  KEY_PRESSED,    // Клавиша нажата
  KEY_DOWN,       // Клавиша полностью нажата
  KEY_RELEASED,   // Клавиша отпущена
  KEY_UP,         // Клавиша полностью отпущена
} event_t;

typedef struct {
  char midi_note:8; // Нота
  state_t       state:4; // Состояние
  unsigned long t_pressed  :32; // Таймер клавиша нажата
  unsigned long t_down  :32; // Таймер клавиша полностью нажата
  unsigned long t_released  :32; // Таймер клавиша отпущена
  unsigned long t_up  :32; // Таймер клавиша полностью отпущена
  unsigned long t_debounce  :32; // Таймер дребезга клавиш

} keyp_t;

typedef struct {
  char top;
  char bottom;
} bank_t;

#endif //MYTYPES_H